Subject: Re: [PATCH 1/2] CI: use shorter names that fit in UX tooltips

From: Junio C Hamano <[email-masked]>
Date: Fri, 19 Nov 2021 14:14:05 -0800

Victoria Dye <[email-masked]> writes:

> Tooltips like the ones you've pointed out here appear intended to be an "at
> a glance" view of the jobs (mostly for showing pass/fail/skip status) - each
> job in the tooltip has a "Details" link that takes you to the job summary
> and logs. In the current state, although the names of the are truncated in
> the tooltip, the information is still easily accessible in the full workflow
> details (one click away). For example, the details for the "linux-leaks" job
> [1] tell me the image, compiler, and job name right at the top of the page.

While that is all true, if the truncated one does not allow viewers
to easily tell between linux-leaks and linux-gcc and what these are
about, there is not much value to have the "tooltips" in the first
place.  The user will be forced to always visit the details, that
defeats the whole point of having an "at a glance" view.

> By optimizing for the tooltip, this patch shortens names to the point that
> they're more difficult to interpret (w32 vs. w32/VS) and/or removes valuable
> context about platform/image/etc. When a user *does* want more information
> on the job, they now have to: 
>
> 1) know that the "CI/PR" job definition is in ".github/workflows/main.yml"
> 2) parse through the file to find the job they want
> 3) correlate that back to the job in the workflow details they're
>    investigating. 

That is something I have to do with the current scheme, too.  I do
not think "windows" -> "w32" makes it much worse.

> If the only problem this patch really "solves" is making some job names fit
> a bit better into the tooltip and, I think the costs (namely the loss of
> accessible contextual info) outweigh any potential benefits you gain. 

I think "fits in the limited space" is a mere approximation of what
renaming effort can achieve.  If we can cram what matters more in
the tight display space we have there, so that we do not have to go
to the details page or to (eek!) the YAML file all the time, that
would be a welcome change.  Between "vs-test (4)" and "w32/vs test
(4)", for example, I do not think there is much difference as both
are equally opaque and I cannot guess what the particular job is
testing.  But if we can have a more informative label, "at a glance"
view would become much more useful, no?

Having said that, I do agree with you that this iteration does a
fairly poor job at it. The only thing that I found very much better
in Ævar's sample run over the current one is the "linux-leaks" Job.
All the other changes were "Meh" to me.

If do you think "what matters" is purely personal taste, and we will
not be able to gain a concensus on which part of the whole string
(before truncation) is more important, then it is a different story.